diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/lib/nameservice/src/compat.c olsrd-current/lib/nameservice/src/compat.c
--- olsrd-0.5.0/lib/nameservice/src/compat.c	2005-06-02 17:34:00.000000000 +0200
+++ olsrd-current/lib/nameservice/src/compat.c	2007-04-20 00:21:34.000000000 +0200
@@ -11,9 +11,6 @@
   size_t len = strlen(ptr);
   char *ret = NULL;
 
-  if(!len)
-    return NULL;
-
   if(len > size)
     len = size;
 
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/lib/nameservice/src/nameservice.c olsrd-current/lib/nameservice/src/nameservice.c
--- olsrd-0.5.0/lib/nameservice/src/nameservice.c	2007-02-06 22:07:11.000000000 +0100
+++ olsrd-current/lib/nameservice/src/nameservice.c	2007-04-28 21:58:49.000000000 +0200
@@ -30,7 +30,7 @@
  *
  */
 
-/* $Id: nameservice.c,v 1.18 2007/02/06 21:07:11 bernd67 Exp $ */
+/* $Id: nameservice.c,v 1.23 2007/04/28 19:58:49 bernd67 Exp $ */
 
 /*
  * Dynamic linked library for UniK OLSRd
@@ -104,7 +104,7 @@
  * do initialization
  */
 void
-name_constructor() 
+name_constructor(void) 
 {
 	int i;
 	
@@ -187,7 +187,7 @@
 		if (strlen(value) == 0) {
             my_forwarders = add_name_to_list(my_forwarders, "", NAME_FORWARDER, NULL);
             olsr_printf(1,"\nNAME PLUGIN: parameter dns-server: (main address)");
-        } else if (inet_pton(olsr_cnf->ip_version, value, &ip)) {
+        } else if (inet_pton(olsr_cnf->ip_version, value, &ip) > 0) {
             my_forwarders = add_name_to_list(my_forwarders, "", NAME_FORWARDER, &ip);
             olsr_printf(1,"\nNAME PLUGIN: parameter dns-server: (%s)", value);
         } else {
@@ -208,7 +208,7 @@
 		// assume this is an IP address and hostname
 		union olsr_ip_addr ip;
 		
-		if (inet_pton(olsr_cnf->ip_version, key, &ip) == 1) {
+		if (inet_pton(olsr_cnf->ip_version, key, &ip) > 0) {
 			// the IP is validated later
             my_names = add_name_to_list(my_names, value, NAME_HOST, &ip);
 			olsr_printf(1,"\nNAME PLUGIN: parameter name %s (%s)", value, key);
@@ -257,18 +257,17 @@
  *   - register_olsr_data() then then finally calls this function
  */
 int
-name_init()
+name_init(void)
 {
 	struct name_entry *name;
 	union olsr_ip_addr ipz;
-
-	memset(&ipz, 0, sizeof(ipz));
-
     int ret;
+
     //regex string for validating the hostnames
     char *regex_name = "^[[:alnum:]_.-]+$";
     //regex string for the service line
     char *regex_service = olsr_malloc(256*sizeof(char) + strlen(my_suffix), "new *char from name_init for regex_service");
+	memset(&ipz, 0, sizeof(ipz));
 
     //compile the regex from the string
 	if ((ret = regcomp(&regex_t_name, regex_name , REG_EXTENDED)) != 0)
@@ -390,7 +389,7 @@
  * XXX: should I delete the hosts/services/resolv.conf files on exit?
  */
 void
-name_destructor()
+name_destructor(void)
 {
 	olsr_printf(2, "NAME PLUGIN: exit. cleaning up...\n");
 	
@@ -412,15 +411,13 @@
 free_all_list_entries(struct db_entry **this_db_list) 
 {
 	int i;
-	struct db_entry **tmp;
-	struct db_entry *to_delete;
 	
 	for(i = 0; i < HASHSIZE; i++)
 	{
-		tmp = &list[i];
+        struct db_entry **tmp = &this_db_list[i];
 		while(*tmp != NULL)
 		{
-			to_delete = *tmp;
+            struct db_entry *to_delete = *tmp;
 			*tmp = (*tmp)->next;
 			free_name_entry_list(&to_delete->names);
 			free(to_delete);
@@ -440,7 +437,7 @@
  * and write changes to file
  */
 void
-olsr_timeout()
+olsr_timeout(void)
 {
     timeout_old_names(list, &name_table_changed);
     timeout_old_names(forwarder_list, &forwarder_table_changed);
@@ -488,7 +485,7 @@
  * Scheduled event: generate and send NAME packet
  */
 void
-olsr_event(void *foo)
+olsr_event(void *foo __attribute__((unused)))
 {
 	union olsr_message *message = (union olsr_message*)buffer;
 	struct interface *ifn;
@@ -531,10 +528,10 @@
 			message->v6.olsr_msgsize = htons(namesize);
 		}
 		
-		if(net_outbuffer_push(ifn, (olsr_u8_t *)message, namesize) != namesize ) {
+		if(net_outbuffer_push(ifn, message, namesize) != namesize ) {
 			/* send data and try again */
 			net_output(ifn);
-			if(net_outbuffer_push(ifn, (olsr_u8_t *)message, namesize) != namesize ) {
+			if(net_outbuffer_push(ifn, message, namesize) != namesize ) {
 				olsr_printf(1, "NAME PLUGIN: could not send on interface: %s\n", ifn->int_name);
 			}
 		}
@@ -679,9 +676,9 @@
 	struct name_entry *tmp;
 	struct name_entry *already_saved_name_entries;
     char *name = (char*)from_packet + sizeof(struct name);
-	olsr_printf(4, "\nNAME PLUGIN: decapsulating received name, service or forwarder \n");
     int type_of_from_packet = ntohs(from_packet->type);
     unsigned int len_of_name = ntohs(from_packet->len);
+	olsr_printf(4, "\nNAME PLUGIN: decapsulating received name, service or forwarder \n");
     
     // don't insert the received entry again, if it has already been inserted in the hash table. 
     // Instead only the validity time is set in insert_new_name_in_list function, which calls this one
@@ -833,7 +830,7 @@
  * write names to a file in /etc/hosts compatible format
  */
 void
-write_hosts_file()
+write_hosts_file(void)
 {
 	int hash;
 	struct name_entry *name;
@@ -914,7 +911,7 @@
  * http://me.olsr:80|tcp|my little homepage
  */
 void
-write_services_file()
+write_services_file(void)
 {
 	int hash;
 	struct name_entry *name;
@@ -972,7 +969,7 @@
  * best means the 3 with the best etx value in routing table
  */
 void
-write_resolv_file()
+write_resolv_file(void)
 {
 	int hash;
 	struct name_entry *name, *tmp_dns, *last_dns, *dnslist = NULL;
@@ -1280,7 +1277,7 @@
     }
     
     //ip in service-line is allowed 
-    if (inet_pton(olsr_cnf->ip_version, hostname_or_ip, &olsr_ip)) {
+    if (inet_pton(olsr_cnf->ip_version, hostname_or_ip, &olsr_ip) > 0) {
         if (allowed_ip(&olsr_ip)) {
             olsr_printf(2, "NAME PLUGIN: ip %s in service %s is OK\n", olsr_ip_to_string(&olsr_ip), service_line);
             free(hostname_or_ip);
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/lib/nameservice/src/olsrd_plugin.c olsrd-current/lib/nameservice/src/olsrd_plugin.c
--- olsrd-0.5.0/lib/nameservice/src/olsrd_plugin.c	2005-05-29 14:47:42.000000000 +0200
+++ olsrd-current/lib/nameservice/src/olsrd_plugin.c	2007-04-20 15:46:02.000000000 +0200
@@ -29,7 +29,7 @@
  *
  */
 
-/* $Id: olsrd_plugin.c,v 1.11 2005/05/29 12:47:42 br1 Exp $ */
+/* $Id: olsrd_plugin.c,v 1.12 2007/04/20 13:46:02 bernd67 Exp $ */
 
 /*
  * Dynamic linked library for olsr.org olsrd
@@ -41,7 +41,6 @@
 #include "olsrd_plugin.h"
 #include "nameservice.h"
 
-
 #define PLUGIN_NAME    "OLSRD nameservice plugin"
 #define PLUGIN_VERSION "0.2"
 #define PLUGIN_AUTHOR   "Bruno Randolf"
@@ -54,22 +53,21 @@
 static void __attribute__ ((destructor)) 
 my_fini(void);
 
-
 int 
-olsrd_plugin_interface_version()
+olsrd_plugin_interface_version(void)
 {
 	return OLSRD_PLUGIN_INTERFACE_VERSION;
 }
 
-
-int olsrd_plugin_init()
+int
+olsrd_plugin_init(void)
 {
 	return name_init();
 }
 
 
 static void
-my_init()
+my_init(void)
 {
 	/* Print plugin info to stdout */
 	printf("%s\n", MOD_DESC);
@@ -81,7 +79,7 @@
 
 
 static void
-my_fini()
+my_fini(void)
 {
 	name_destructor();
 }
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/lib/pgraph/README_PGRAPH olsrd-current/lib/pgraph/README_PGRAPH
--- olsrd-0.5.0/lib/pgraph/README_PGRAPH	1970-01-01 01:00:00.000000000 +0100
+++ olsrd-current/lib/pgraph/README_PGRAPH	2007-04-03 11:48:45.000000000 +0200
@@ -0,0 +1,69 @@
+README-OLSR
+Modified: 05/17/2005
+
+#========================================================================
+#  These programs NEVER meet your needs.  In fact, they can cause
+#  serious damages to your precious things, including, but not being
+#  limited to, time, money, effort, computer files, information,
+#  hardware, software, and other things that you value.
+#
+#  The author DOES NOT request or even suggest that you use any of these
+#  programs. You understand clearly that you are taking a big risk
+#  in using these programs and that you are completely (100%) liable
+#  for using them.
+#
+#  You further understand that although you can use these programs
+#  without paying the author or the employer of the author, you
+#  do not own them.  You will give proper credits to the
+#  author and his employer whenever you use them; i.e.,
+#  you will never pretend that you are the author of these programs.
+#  If you make any changes to them, you will send a copy
+#  of each modified programs to the author.  You will also NEVER
+#  sell or give any of them to anyone else without the approval of the
+#  author or his employer.
+
+
+Parser: OLSRConnect.py
+Description: This parser has been written to interface with a plugin for
+	     the version 4.9 OLSR from olsr.org.  The plugin can also be 
+	     found in this directory.  
+
+Parser for OLSR: 	OLSRConnect.py
+Plugin for OLSRv4.9:	olsr_v4.9-pgraph-plugin
+
+Usage:
+	1) Copy the "olsr_v4.9-pgraph-plugin" directory from this distribution
+	   to the "/<your OLSRv4.9 path>/lib/."
+
+	2) cd to the "/<your OLSRv4.9 path>/lib/." directory, 
+           run "make" and "make install"
+	   This will create the "olsrd_pgraph.so.1.1" file and install it. 
+
+	3) Modify the "/etc/olsrd.conf" file of the system you wish to
+	   monitor from to load the plugin. 
+	   Add the line: "LoadPlugin "olsrd_pgraph.so.1.1" {}"
+
+	4) The plugin actually allows any host to connect regardless of
+           what is specified in the olsrd.conf file.  This is currently 
+           done for testing purposes and due to the fact that the "Host" 
+           parameter in the olsrd.conf file never worked.  
+
+           # By default only localhost will be able to connect to the IPC
+	   # system of the olsrd process so if you are not going to be 
+	   # running pgraph locally, modify the "Host" variable of the 
+	   # "IpcConnect" structure in the "/etc/olsrd.conf" file to 
+	   # reflect the IP address of the host you will be connecting from. 
+
+	5) Start olsrd and make sure that the plugin has loaded correctly.
+
+	6) On the machine you will be running pgraph from, use the 
+	   "OLSRConnect.py" parser to connect to the olsrd plugin and pipe
+	   the output to pgraph. 
+
+Usage: (note the use of the backquote "`") 
+"python  OLSRConnect.py <ip of machine running plugin> 2004 | `python pgraph.py`"
+
+- Where the "2004" above is the default port that the plugin will be listening on.
+
+To kill pgraph when using the parser:
+- Hit "Ctl-C" in the terminal. 
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/lib/pgraph/src/olsrd_pgraph.c olsrd-current/lib/pgraph/src/olsrd_pgraph.c
--- olsrd-0.5.0/lib/pgraph/src/olsrd_pgraph.c	2006-01-07 09:17:43.000000000 +0100
+++ olsrd-current/lib/pgraph/src/olsrd_pgraph.c	2007-04-28 22:48:57.000000000 +0200
@@ -37,7 +37,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: olsrd_pgraph.c,v 1.3 2006/01/07 08:17:43 kattemat Exp $
+ * $Id: olsrd_pgraph.c,v 1.5 2007/04/28 20:48:57 bernd67 Exp $
  */
 
 /*
@@ -56,28 +56,42 @@
 #define close(x) closesocket(x)
 #endif
 
-int ipc_socket;
-int ipc_open;
-int ipc_connection;
-int ipc_socket_up;
+static int ipc_socket;
+static int ipc_open;
+static int ipc_connection;
+static int ipc_socket_up;
 
-static void inline
+static void
+ipc_print_neigh_link(struct neighbor_entry *neighbor);
+
+static void
+ipc_print_tc_link(struct tc_entry *entry, struct topo_dst *dst_entry);
+
+#if 0
+static void
+ipc_print_net(union olsr_ip_addr *, union olsr_ip_addr *, union hna_netmask *);
+#endif
+
+static int
+ipc_send(const char *, int);
+
+static void
 ipc_print_neigh_link(struct neighbor_entry *);
 
-int
+static int
 plugin_ipc_init(void);
 
 void
 olsr_plugin_exit(void);
 
 
-static void inline
+static void
 ipc_print_neigh_link(struct neighbor_entry *neighbor)
 {
   char buf[256];
   int len;
-  char* main_adr;
-  char* adr;
+  const char* main_adr;
+  const char* adr;
 //  double etx=0.0;
 //  char* style = "solid";
 //  struct link_entry* link;
@@ -120,7 +134,7 @@
  *function in uolsrd_plugin.c
  */
 int
-olsrd_plugin_init()
+olsrd_plugin_init(void)
 {
 
   /* Initial IPC value */
@@ -134,7 +148,7 @@
 }
 
 int
-plugin_ipc_init()
+plugin_ipc_init(void)
 {
   struct sockaddr_in sin;
   olsr_u32_t yes = 1;
@@ -193,7 +207,7 @@
 }
 
 void
-ipc_action(int fd)
+ipc_action(int fd __attribute__((unused)))
 {
   struct sockaddr_in pin;
   socklen_t addrlen;
@@ -235,7 +249,7 @@
  * destructor - called at unload
  */
 void
-olsr_plugin_exit()
+olsr_plugin_exit(void)
 {
   if(ipc_open)
     close(ipc_socket);
@@ -249,7 +263,7 @@
 int
 pcf_event(int changes_neighborhood,
 	  int changes_topology,
-	  int changes_hna)
+	  int changes_hna __attribute__((unused)))
 {
   int res;
   olsr_u8_t index;
@@ -344,13 +358,13 @@
 }
 #endif
 
-static void inline
+static void
 ipc_print_tc_link(struct tc_entry *entry, struct topo_dst *dst_entry)
 {
   char buf[256];
   int len;
-  char* main_adr;
-  char* adr;
+  const char* main_adr;
+  const char* adr;
 //  double etx = calc_etx( dst_entry->link_quality, dst_entry->inverse_link_quality );
 
   main_adr = olsr_ip_to_string(&entry->T_last_addr);
@@ -359,10 +373,11 @@
   ipc_send(buf, len);
 }
 
-static void inline
+#if 0
+static void
 ipc_print_net(union olsr_ip_addr *gw, union olsr_ip_addr *net, union hna_netmask *mask)
 {
-  char *adr;
+  const char *adr;
 
   adr = olsr_ip_to_string(gw);
   ipc_send("\"", 1);
@@ -383,11 +398,11 @@
   ipc_send("\"", 1);
   ipc_send("[shape=diamond];\n", strlen("[shape=diamond];\n"));
 }
-
+#endif
 
 
 int
-ipc_send(char *data, int size)
+ipc_send(const char *data, int size)
 {
   if(!ipc_open)
     return 0;
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/lib/pgraph/src/olsrd_pgraph.h olsrd-current/lib/pgraph/src/olsrd_pgraph.h
--- olsrd-0.5.0/lib/pgraph/src/olsrd_pgraph.h	2005-07-13 23:45:08.000000000 +0200
+++ olsrd-current/lib/pgraph/src/olsrd_pgraph.h	2007-04-20 15:46:03.000000000 +0200
@@ -37,7 +37,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: olsrd_pgraph.h,v 1.1 2005/07/13 21:45:08 kattemat Exp $
+ * $Id: olsrd_pgraph.h,v 1.2 2007/04/20 13:46:03 bernd67 Exp $
  */
 
 /*
@@ -73,7 +73,7 @@
 extern struct in_addr ipc_accept_ip;
 extern int ipc_port;
 
-char netmask[5];
+extern char netmask[5];
 
 /* Event function to register with the sceduler */
 int
@@ -82,18 +82,6 @@
 void
 ipc_action(int);
 
-static void inline
-ipc_print_neigh_link(struct neighbor_entry *neighbor);
-
-static void inline
-ipc_print_tc_link(struct tc_entry *entry, struct topo_dst *dst_entry);
-
-static void inline
-ipc_print_net(union olsr_ip_addr *, union olsr_ip_addr *, union hna_netmask *);
-
-int
-ipc_send(char *, int);
-
 char *
 olsr_netmask_to_string(union hna_netmask *);
 
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/lib/pgraph/src/olsrd_plugin.c olsrd-current/lib/pgraph/src/olsrd_plugin.c
--- olsrd-0.5.0/lib/pgraph/src/olsrd_plugin.c	2005-07-13 23:45:08.000000000 +0200
+++ olsrd-current/lib/pgraph/src/olsrd_plugin.c	2007-04-20 15:46:03.000000000 +0200
@@ -36,7 +36,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: olsrd_plugin.c,v 1.1 2005/07/13 21:45:08 kattemat Exp $
+ * $Id: olsrd_plugin.c,v 1.2 2007/04/20 13:46:03 bernd67 Exp $
  */
 
 /*
@@ -78,7 +78,7 @@
  * Do not alter unless you know what you are doing!
  */
 int 
-olsrd_plugin_interface_version()
+olsrd_plugin_interface_version(void)
 {
   return PLUGIN_INTERFACE_VERSION;
 }
@@ -88,7 +88,7 @@
  *Constructor
  */
 void
-my_init()
+my_init(void)
 {
   /* Print plugin info to stdout */
   printf("%s\n", MOD_DESC);
@@ -104,7 +104,7 @@
  *Destructor
  */
 void
-my_fini()
+my_fini(void)
 {
 
   /* Calls the destruction function
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/lib/quagga/README_QUAGGA olsrd-current/lib/quagga/README_QUAGGA
--- olsrd-0.5.0/lib/quagga/README_QUAGGA	1970-01-01 01:00:00.000000000 +0100
+++ olsrd-current/lib/quagga/README_QUAGGA	2007-04-03 11:48:45.000000000 +0200
@@ -0,0 +1,58 @@
+---------------------------------------------------------------------
+QUAGGA PLUGIN FOR OLSRD
+by Immo 'FaUl' Wehrenberg <immo@chaostreff-dortmund.de>
+---------------------------------------------------------------------
+
+This is the Quagga Plugin for the OLSRD. 
+It allowes olsrd to redistribute from various quagga-protocols 
+as well as to export olsr-routes to quagga so that they can be
+redistributed by the quagga-routing-daemons.
+
+Note Sven-Ola: You also need a source distribution of quagga-0.98.5
+or quagga-0.98.6 (that is the current stable). The quagga source tree 
+needs to be patched with quagga-0.98.6-olsr.diff, compiled and installed
+via 'make install'. Because many people will otherwise have compile
+probs, I've added 2 include files in lib/quagga/src/quagga. If you
+want to use another version of quagga, make sure to remove these
+before you compile the olsrd_quagga plugin.
+
+---------------------------------------------------------------------
+PLUGIN PARAMETERS (PlParam)
+---------------------------------------------------------------------
+
+PlParam "redistribute" "<protocol>"
+	where protocol is one of the following:
+	system, kernel, connect, static, rip, ripng, ospf, ospf6,
+	isis, bgp, hsls
+	May be used more then once
+
+PlParam "ExportRoutes" "<only/both>"
+	exportes olsr-routes to quagga or to both, quagga and kernel
+	no routes are exportet if not set.
+
+PlParam "LocalPref" "true"
+        sets the zebra SELECTED-flag on the routes exported to zebra
+	which means these routes are prefered in any case.
+
+PlParam "Distance" "0-255"
+        allowes to set Administrative distance to routes exported 
+	to zebra.
+	
+---------------------------------------------------------------------
+SAMPLE CONFIG
+---------------------------------------------------------------------
+
+add in /etc/olsrd.conf:
+
+LoadPlugin "olsrd_quagga.so.0.2.2"
+{
+	PlParam "redistribute" "ospf"
+	PlParam "redistribute" "bgp"
+	PlParam "ExportRoutes" "only"
+	PlParam "Distance" "125" 
+	PlParam "LocalPref" "false"
+}
+
+
+---------------------------------------------------------------------
+EOF / 8.5.2006
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/lib/secure/README_SECURE olsrd-current/lib/secure/README_SECURE
--- olsrd-0.5.0/lib/secure/README_SECURE	1970-01-01 01:00:00.000000000 +0100
+++ olsrd-current/lib/secure/README_SECURE	2007-04-03 11:48:45.000000000 +0200
@@ -0,0 +1,64 @@
+
+
+Secure OLSR 0.4 implementation notes
+(c)Andreas Tønnesen 2004
+
+This document contains information on how to
+use the secure OLSR plugin with the UniK olsr daemon.
+It does _not_ cover secure OLSR protocol issues.
+
+Lines starting with '# ' indicates shell commands.
+
+NOTES
+
+  The plugin interface and olsrd output buffering was
+  heavily rewritten for the 0.4.8 release. The plugin
+  should work with this release - but has not been
+  tested much.
+
+COMPILING
+
+  To compile simply do:
+  # make
+  This compiles the local MD5 function and the plugin has
+  no external dependencies.
+  If you want the plugin to use SHA-1 using the openssl libs
+  do:
+  # make USE_OPENSSL=1
+
+INSTALLING
+
+  To install:
+  # make install
+
+  This will run ldconfig to update the dynamic linker.
+  It might take a while.
+
+USAGE
+
+  To make olsrd load the secure OLSR plugin add the
+  following in the olsrd configuration file:
+
+LoadPlugin "olsrd_secure.so.0.4"
+{
+    PlParam     "Keyfile"   "FILENAME"
+}
+
+  replacing FILENAME with the full path of the file
+  containing the shared key.
+
+  The plugin uses this shared secret key for signature
+  generation and verification. For nodes to participate 
+  in the OLSR routing domain they need to use the key 
+  used by the other nodes.
+  The key is 128-bits of size and is read from the
+  specified file from the config file or by default from:
+  /etc/olsrd.d/olsrd_secure_key
+
+  Copy the key to this file an all nodes. The plugin
+  will terminate olsrd if this file cannot be found.
+
+  Now start olsrd and the let the plugin do its
+  thing :)
+
+- Andreas
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/lib/secure/src/olsrd_plugin.c olsrd-current/lib/secure/src/olsrd_plugin.c
--- olsrd-0.5.0/lib/secure/src/olsrd_plugin.c	2005-05-29 14:47:43.000000000 +0200
+++ olsrd-current/lib/secure/src/olsrd_plugin.c	2007-04-20 15:46:03.000000000 +0200
@@ -33,7 +33,7 @@
  * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
  * POSSIBILITY OF SUCH DAMAGE.
  *
- * $Id: olsrd_plugin.c,v 1.10 2005/05/29 12:47:43 br1 Exp $
+ * $Id: olsrd_plugin.c,v 1.11 2007/04/20 13:46:03 bernd67 Exp $
  */
 
 
@@ -63,18 +63,17 @@
  * Do not alter unless you know what you are doing!
  */
 int 
-olsrd_plugin_interface_version()
+olsrd_plugin_interface_version(void)
 {
   return OLSRD_PLUGIN_INTERFACE_VERSION;
 }
 
 
-
 /**
  *Constructor
  */
 static void
-my_init()
+my_init(void)
 {
   /* Print plugin info to stdout */
   /* We cannot use olsr_printf yet! */
@@ -86,7 +85,7 @@
  *Destructor
  */
 static void
-my_fini()
+my_fini(void)
 {
 
   /* Calls the destruction function
@@ -112,7 +111,7 @@
 
 
 int
-olsrd_plugin_init() {
+olsrd_plugin_init(void) {
   /* Calls the initialization function
    * olsr_plugin_init()
    * This function should be present in your
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/lib/secure/src/olsrd_secure.c olsrd-current/lib/secure/src/olsrd_secure.c
--- olsrd-0.5.0/lib/secure/src/olsrd_secure.c	2007-01-31 13:36:49.000000000 +0100
+++ olsrd-current/lib/secure/src/olsrd_secure.c	2007-05-09 19:41:17.000000000 +0200
@@ -33,7 +33,7 @@
  * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
  * POSSIBILITY OF SUCH DAMAGE.
  *
- * $Id: olsrd_secure.c,v 1.21 2007/01/31 12:36:49 bernd67 Exp $
+ * $Id: olsrd_secure.c,v 1.25 2007/05/09 17:41:17 bernd67 Exp $
  */
 
 
@@ -115,7 +115,7 @@
  */
 
 int
-secure_plugin_init()
+secure_plugin_init(void)
 {
   struct interface *ints;
   int i;
@@ -174,7 +174,7 @@
 
 
 int
-plugin_ipc_init()
+plugin_ipc_init(void)
 {
   return 1;
 }
@@ -184,7 +184,7 @@
  * destructor - called at unload
  */
 void
-secure_plugin_exit()
+secure_plugin_exit(void)
 {
 }
 
@@ -193,14 +193,14 @@
  *Scheduled event
  */
 void
-olsr_event()
+olsr_event(void)
 {
 
 }
 
 
 int
-ipc_send(char *data, int size)
+ipc_send(char *data __attribute__((unused)), int size __attribute__((unused)))
 {
   return 1;
 }
@@ -358,7 +358,7 @@
  *
  */
 int
-check_auth(char *pck, int *size)
+check_auth(char *pck, int *size __attribute__((unused)))
 {
 
   olsr_printf(3, "[ENC]Checking packet for challenge response message...\n");
@@ -426,7 +426,7 @@
   
   /* Add timestamp */
   msg->sig.timestamp = htonl(now.tv_sec);
-  olsr_printf(3, "[ENC]timestamp: %d\n", now.tv_sec);
+  olsr_printf(3, "[ENC]timestamp: %ld\n", now.tv_sec);
   
   /* Set the new size */
   *size = *size + sizeof(struct s_olsrmsg);
@@ -593,7 +593,7 @@
       return 0;
     }
 
-  olsr_printf(1, "[ENC]Received timestamp %d diff: %d\n", rec_time, now.tv_sec - rec_time);
+  olsr_printf(1, "[ENC]Received timestamp %ld diff: %ld\n", rec_time, now.tv_sec - rec_time);
 
   /* Remove signature message */
   *size = packetsize;
@@ -684,7 +684,7 @@
   memcpy(&cmsg.destination, new_host, olsr_cnf->ipsize);
   cmsg.challenge = htonl(challenge);
 
-  olsr_printf(3, "[ENC]Size: %d\n", sizeof(struct challengemsg));
+  olsr_printf(3, "[ENC]Size: %lu\n", (unsigned long)sizeof(struct challengemsg));
 
   {
   olsr_u8_t checksum_cache[512 + KEYLENGTH];
@@ -704,7 +704,7 @@
 	      challenge);
 
   /* Add to buffer */
-  net_outbuffer_push(olsr_in_if, (olsr_u8_t *)&cmsg, sizeof(struct challengemsg));
+  net_outbuffer_push(olsr_in_if, &cmsg, sizeof(struct challengemsg));
 
   /* Send the request */
   net_output(olsr_in_if);
@@ -752,7 +752,7 @@
       return 0;
     }
 
-  olsr_printf(3, "[ENC]Challenge: 0x%x\n", ntohl(msg->challenge));
+  olsr_printf(3, "[ENC]Challenge: 0x%lx\n", (unsigned long)ntohl(msg->challenge)); /* ntohl() returns a unsignedlong onwin32 */
 
   /* Check signature */
 
@@ -979,7 +979,7 @@
 	}
     }
 
-  olsr_printf(3, "[ENC]Challenge: 0x%x\n", ntohl(msg->challenge));
+  olsr_printf(3, "[ENC]Challenge: 0x%lx\n", (unsigned long)ntohl(msg->challenge)); /* ntohl() returns a unsignedlong onwin32 */
 
   /* Check signature */
 
@@ -1056,7 +1056,7 @@
 
   /* set timestamp */
   crmsg.timestamp = now.tv_sec;
-  olsr_printf(3, "[ENC]Timestamp %d\n", crmsg.timestamp);
+  olsr_printf(3, "[ENC]Timestamp %ld\n", crmsg.timestamp);
 
   /* Fill subheader */
   memcpy(&crmsg.destination, to, olsr_cnf->ipsize);
@@ -1099,7 +1099,7 @@
 	      challenge);
 
   /* Add to buffer */
-  net_outbuffer_push(olsr_in_if, (olsr_u8_t *)&crmsg, sizeof(struct c_respmsg));
+  net_outbuffer_push(olsr_in_if, &crmsg, sizeof(struct c_respmsg));
   /* Send the request */
   net_output(olsr_in_if);
 
@@ -1135,7 +1135,7 @@
 
   /* set timestamp */
   rrmsg.timestamp = now.tv_sec;
-  olsr_printf(3, "[ENC]Timestamp %d\n", rrmsg.timestamp);
+  olsr_printf(3, "[ENC]Timestamp %ld\n", rrmsg.timestamp);
 
   /* Fill subheader */
   memcpy(&rrmsg.destination, to, olsr_cnf->ipsize);
@@ -1176,7 +1176,7 @@
 	      olsr_ip_to_string(to));
 
   /* add to buffer */
-  net_outbuffer_push(olsr_in_if, (olsr_u8_t *)&rrmsg, sizeof(struct r_respmsg));
+  net_outbuffer_push(olsr_in_if, &rrmsg, sizeof(struct r_respmsg));
 
   /* Send the request */
   net_output(olsr_in_if);
@@ -1218,7 +1218,7 @@
  *@return nada
  */
 void
-timeout_timestamps(void* foo)
+timeout_timestamps(void* foo __attribute__((unused)))
 {
   struct stamp *tmp_list;
   struct stamp *entry_to_delete;
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/lib/tas/src/glua.c olsrd-current/lib/tas/src/glua.c
--- olsrd-0.5.0/lib/tas/src/glua.c	2005-11-16 00:46:19.000000000 +0100
+++ olsrd-current/lib/tas/src/glua.c	2007-04-20 15:46:03.000000000 +0200
@@ -37,7 +37,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: glua.c,v 1.3 2005/11/15 23:46:19 tlopatic Exp $
+ * $Id: glua.c,v 1.4 2007/04/20 13:46:03 bernd67 Exp $
  */
 
 #include "lua/lua.h"
@@ -229,7 +229,7 @@
   return 0;
 }
 
-static int luaWriter(lua_State *lua, const void *buff, int len, FILE *file)
+static int luaWriter(lua_State *lua __attribute__((unused)), const void *buff, int len, FILE *file)
 {
   return fwrite(buff, len, 1, file) == 1;
 }
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/lib/tas/src/lib.h olsrd-current/lib/tas/src/lib.h
--- olsrd-0.5.0/lib/tas/src/lib.h	2005-04-12 21:57:26.000000000 +0200
+++ olsrd-current/lib/tas/src/lib.h	2007-04-20 15:46:03.000000000 +0200
@@ -37,9 +37,12 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: lib.h,v 1.2 2005/04/12 19:57:26 tlopatic Exp $
+ * $Id: lib.h,v 1.3 2007/04/20 13:46:03 bernd67 Exp $
  */
 
+#ifndef _OLSRD_TAS_LIB_H
+#define _OLSRD_TAS_LIB_H
+
 #define DEBUG_MESSAGE 1
 #define DEBUG_SESSION 2
 #define DEBUG_CONNECTION 4
@@ -47,10 +50,12 @@
 #define DEBUG_LUA 16
 #define DEBUG_QUANTUM 32
 
-extern void error(char *form, ...);
-extern void debug(int facility, char *form, ...);
+extern void error(char *form, ...) __attribute__((format(printf,1,2)));
+extern void debug(int facility, char *form, ...) __attribute__((format(printf,2,3)));
 extern char *strdupAdd(const char *string, int add);
 extern char *myStrdup(const char *string);
 extern void chomp(char *line, int len);
 extern char *intToString(char *buff, unsigned int val);
 extern int stringToInt(unsigned int *val, const char *buff);
+
+#endif
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/lib/tas/src/lua/lapi.c olsrd-current/lib/tas/src/lua/lapi.c
--- olsrd-0.5.0/lib/tas/src/lua/lapi.c	2005-04-12 19:17:26.000000000 +0200
+++ olsrd-current/lib/tas/src/lua/lapi.c	2007-04-20 15:46:03.000000000 +0200
@@ -1,5 +1,5 @@
 /*
-** $Id: lapi.c,v 1.1 2005/04/12 17:17:26 tlopatic Exp $
+** $Id: lapi.c,v 1.2 2007/04/20 13:46:03 bernd67 Exp $
 ** Lua API
 ** See Copyright Notice in lua.h
 */
@@ -805,7 +805,6 @@
   api_checknelems(L, 1);
   luaG_errormsg(L);
   lua_unlock(L);
-  return 0;  /* to avoid warnings */
 }
 
 
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/lib/tas/src/lua/lauxlib.c olsrd-current/lib/tas/src/lua/lauxlib.c
--- olsrd-0.5.0/lib/tas/src/lua/lauxlib.c	2005-04-12 19:17:26.000000000 +0200
+++ olsrd-current/lib/tas/src/lua/lauxlib.c	2007-04-20 15:46:03.000000000 +0200
@@ -1,5 +1,5 @@
 /*
-** $Id: lauxlib.c,v 1.1 2005/04/12 17:17:26 tlopatic Exp $
+** $Id: lauxlib.c,v 1.2 2007/04/20 13:46:03 bernd67 Exp $
 ** Auxiliary functions for building Lua libraries
 ** See Copyright Notice in lua.h
 */
@@ -50,11 +50,11 @@
   if (strcmp(ar.namewhat, "method") == 0) {
     narg--;  /* do not count `self' */
     if (narg == 0)  /* error is in the self argument itself? */
-      return luaL_error(L, "calling `%s' on bad self (%s)", ar.name, extramsg);
+      luaL_error(L, "calling `%s' on bad self (%s)", ar.name, extramsg);
   }
   if (ar.name == NULL)
     ar.name = "?";
-  return luaL_error(L, "bad argument #%d to `%s' (%s)",
+  luaL_error(L, "bad argument #%d to `%s' (%s)",
                         narg, ar.name, extramsg);
 }
 
@@ -62,10 +62,11 @@
 LUALIB_API int luaL_typerror (lua_State *L, int narg, const char *tname) {
   const char *msg = lua_pushfstring(L, "%s expected, got %s",
                                     tname, lua_typename(L, lua_type(L,narg)));
-  return luaL_argerror(L, narg, msg);
+  luaL_argerror(L, narg, msg);
 }
 
 
+static void tag_error (lua_State *L, int narg, int tag) __attribute__((noreturn));
 static void tag_error (lua_State *L, int narg, int tag) {
   luaL_typerror(L, narg, lua_typename(L, tag)); 
 }
@@ -91,7 +92,7 @@
   lua_pushvfstring(L, fmt, argp);
   va_end(argp);
   lua_concat(L, 2);
-  return lua_error(L);
+  lua_error(L);
 }
 
 /* }====================================================== */
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/lib/tas/src/lua/lauxlib.h olsrd-current/lib/tas/src/lua/lauxlib.h
--- olsrd-0.5.0/lib/tas/src/lua/lauxlib.h	2005-04-12 19:17:26.000000000 +0200
+++ olsrd-current/lib/tas/src/lua/lauxlib.h	2007-04-20 15:46:03.000000000 +0200
@@ -1,5 +1,5 @@
 /*
-** $Id: lauxlib.h,v 1.1 2005/04/12 17:17:26 tlopatic Exp $
+** $Id: lauxlib.h,v 1.2 2007/04/20 13:46:03 bernd67 Exp $
 ** Auxiliary functions for building Lua libraries
 ** See Copyright Notice in lua.h
 */
@@ -31,8 +31,8 @@
                                const luaL_reg *l, int nup);
 LUALIB_API int luaL_getmetafield (lua_State *L, int obj, const char *e);
 LUALIB_API int luaL_callmeta (lua_State *L, int obj, const char *e);
-LUALIB_API int luaL_typerror (lua_State *L, int narg, const char *tname);
-LUALIB_API int luaL_argerror (lua_State *L, int numarg, const char *extramsg);
+LUALIB_API int luaL_typerror (lua_State *L, int narg, const char *tname) __attribute__((noreturn));
+LUALIB_API int luaL_argerror (lua_State *L, int numarg, const char *extramsg) __attribute__((noreturn));
 LUALIB_API const char *luaL_checklstring (lua_State *L, int numArg, size_t *l);
 LUALIB_API const char *luaL_optlstring (lua_State *L, int numArg,
                                            const char *def, size_t *l);
@@ -48,7 +48,7 @@
 LUALIB_API void *luaL_checkudata (lua_State *L, int ud, const char *tname);
 
 LUALIB_API void luaL_where (lua_State *L, int lvl);
-LUALIB_API int luaL_error (lua_State *L, const char *fmt, ...);
+LUALIB_API int luaL_error (lua_State *L, const char *fmt, ...) __attribute__((noreturn));
 
 LUALIB_API int luaL_findstring (const char *st, const char *const lst[]);
 
